package com.example.happy_bird;


import javafx.scene.Node;

public abstract class GameObject extends Node {
    protected int xKoord;
    protected int yKoord;
    protected int width;
    protected int height;
    protected boolean isPassedOn = false;

    /***
     * Konstruktor GameObject
     * Variablen werden zugewiesen
     * @param x      x-Position
     * @param y      y-Position
     * @param width  Breite
     * @param height Höhe
     */
    public GameObject(int x, int y, int width, int height) {
        this.xKoord = x;
        this.yKoord = y;
        this.width = width;
        this.height = height;
    }


    public abstract void setImage();

    /***
     * Setzt ein Object auf eine neue Position
     * param newX  neue x-Position
     */
    public abstract void resetToNewPosition(int newX);

    /*
    // Prüfung ob Rectangle true oder false ist
    public boolean intersect(Rectangle rectangle) {
        return rectangle.intersects(topPipe) || rectangle.intersects(bottomPipe);
    }

    // Röhren Counter → Check, wenn Röhre durchflogen ist
    public boolean passedOn(Rectangle rectangle) {
        return rectangle.x > xKoord + width && !isPassedOn;
    }

    // Bei Bewegung der X Koordinate werden Röhren generiert
    public void moveX(int dx) {
        xKoord -= dx;
        topPipe.x -= dx;
        bottomPipe.x -= dx;
    }*/
}
